/*
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
|| Coder  : [DA] PROxFTW
|| Name   : MysteryBox2.gsc
|| Credits: Treyarch
|| Version: 2.1
|| ** If you would like anything from this file. Please msg me rather than taking my stuff. Thank you **
||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
*/
#include maps\_utility; 
#include common_scripts\utility;
#include maps\_zombiemode_utility;
#include maps\_anim;

#using_animtree( "magic_box" );
// Certain settings have been disabled, will plan to add them when I have time, others are broken slightly, will be fixed, just want a version with features people would most prefer
// User Friendly Start
SetupUserFriendly()
{
	SetupSounds();
	AnimSetup();
	WeaponSetup();
	StringSetup();
	BoxSetup();
	FxSetup();
}

SetupSounds()
{
	// All values should be strings of sounds
	// Leave blank if no sound exist otherwise it will lag at certain parts
	AddSetting( "FireSaleVox", "" );
	AddSetting( "FireSale", "" );
	AddSetting( "OpenBox", "open_chest" );
	AddSetting( "BoxMusic", "music_chest" );
	AddSetting( "BoxLeave", "whoosh" );
	AddSetting( "BoxMove", "box_move" );
	AddSetting( "BoxPoof", "box_poof" );
	AddSetting( "BoxArrive", "box_poof_land" );
	AddSetting( "BoxVox", "ann_vox_magicbox" );
	AddSetting( "SpawnPO", "spawn_powerup" );
	AddSetting( "POLoop", "spawn_powerup_loop" );
	LaunchToArraySound( 4, 5 );
}

AnimSetup()
{
	// All values should be animations in magic_box.atr, besides setting #1
	AddSetting( "IsAnimated", false );
	AddSetting( "AnimatedOpen", %o_lattice_gate_open );
	AddSetting( "AnimatedClose", %o_lattice_gate_open );
	AddSetting( "AnimatedArrive", %o_lattice_gate_open );
	AddSetting( "AnimatedLeave", %o_lattice_gate_open );
}

WeaponSetup()
{
	// All values should be weapon names, or array weapon names, besides setting #2
	AddSetting( "StartPistol", "zombie_colt" );
	AddSetting( "HasMultPistols", false );
	AddSetting( "MultPistols", StrTok( "weapon_name|weapon_name|weapon_name", "|" ) );
	AddSetting( "Minigun", "" );
	AddSetting( "EMP", "" );
	AddSetting( "Gersch", "" );
	AddSetting( "Monkey", "zombie_cymbal_monkey" );
	AddSetting( "Molotov", "molotov" );
	AddSetting( "MolotovZomb", "molotov_zombie" );
	AddSetting( "Dolls", "" );
	AddSetting( "Retriever", "" );
	AddSetting( "RetrieverUpgraded", "" );
	AddSetting( "Betty", "mine_bouncing_betty" );
	AddSetting( "Claymore", "" );
	AddSetting( "Hacker", "zombie_ppsh" );
	AddSetting( "Equipment", StrTok( "weapon_name|weapon_name|weapon_name", "|" ) );
	AddSetting( "MeleeType", StrTok( "weapon_name|weapon_name|weapon_name", "|" ) );
	AddSetting( "Grenades", StrTok( "stielhandgranate|fraggrenade", "|" ) );
	AddSetting( "TacGrenades", StrTok( "weapon_name|weapon_name|weapon_name", "|" ) );
}

StringSetup()
{
	// All values should be strings
	AddSetting( "OpenString", "Press &&1 for Mystery Box [Cost: 950]" );
	AddSetting( "FireSaleOpenString", "Press &&1 for Mystery Box [Cost: 10]" );
	AddSetting( "TradeString", "Press &&1 to Trade Weapon" );
	// Locking Disabled for now
	AddSetting( "LockedString", "Press &&1 to unlock Mystery Box [Cost: 2000]" );
	AddSetting( "RespinString", "Press &&1 to hack [Cost: 600]" );
	AddSetting( "Respinx2String", "Press &&1 to hack" );
	AddSetting( "HackString", "Press &&1 to hack [Cost: 1200]" );
	// Shouldn't see this string but why not add it incase something messes up
	AddSetting( "NotAvailable", "Hacking not available on box" );
}

BoxSetup()
{
	// Setting #1 Info: -1 - Everywhere | -2 - Nowhere | 0 to ( Max number of boxes - 1 ) - 1 location | -3 - Random | -4 - Random but start location | -5 - Random but certain spots
	AddSetting( "BoxLocation", 0 );
	// If setting #1 is -4, specify start location
	AddSetting( "StartZone", "start_zone" );
	// If setting #1 is -5, specify bad zones
	AddSetting( "RemoveZones", StrTok( "ex1|ex2|ex3|ex4", "|" ) );
	AddSetting( "PlayerTakePlayerWeapon", false );
	// If setting #4 is true, specify time before weapon can be taken by another player
	AddSetting( "ChooseNextBoxRandom", false );
	AddSetting( "PlayerTakeTime", 6 );
	AddSetting( "BoxOpenTime", 12 );
	AddSetting( "TeddyModel", "zombie_teddybear" );
	AddSetting( "BoxCanLock", false );
	AddSetting( "BetterWeaponOdds", false );
	AddSetting( "BWOFromAllWeapons", false );
	AddSetting( "Firesale1min", false );
	AddSetting( "LeroyEffect", false );
	AddSetting( "LockBoxDuringSale", false );
	AddSetting( "EmpCanDisableBox", false );
	AddSetting( "EmpCanDisableBoxDuringSale", false );
	AddSetting( "LeroyEffect", false );
	AddSetting( "BoxCost", 950 );
	AddSetting( "SaleCost", 10 );
	AddSetting( "SummonHackCost", 1200 );
	AddSetting( "RespinHackCost", 600 );
	AddSetting( "Respinx2HackCost", 600 );
	AddSetting( "MOTDStyleBox", false );
	AddSetting( "UseBO2RandSystem", false );
}

FxSetup()
{
	// Put fx from level._effect[fx] as the value for these settings
	AddSetting( "OpenFx", "chest_light" );
	AddSetting( "LocationFx", "lght_marker" );
	AddSetting( "SoloPowerupFx", "powerup_on" );
}
// User Friendly End

// Box Start
ChestInit()
{
	flag_init( "moving_chest_enable" );
	flag_init( "moving_chest_now" );

	Chest = GetChest();
	if( Chest.size < 1 || !IsDefined( Chest ) )
		return;

	SetupUserFriendly();
	SetupFireSale();
	Loc = GetStartLocation( Chest );
	if( Loc == -2 )
		return;
	level.chestUsed = 0;
	if( Loc != -1 )
		PandoraLight( Loc );
	else
	{
		for( i = 0; i < Chest.size; i++ )
			PandoraLight( i, true );
	}
	InitStartChest( Chest, Loc );
	for( i = 0; i < Chest.size; i++ )
	{
		GetTeddyBear( Chest[i] ) Hide();
		Chest[i] thread TreasureChestThink();
		Chest[i] thread WatchHintStringStatus();
		// Chest[i] thread InitHackableBox();
	}
}

SetupFireSale()
{
	AddSetting( "FireSaleActive", false );
	level thread WatchFireSale();
}

WatchFireSale()
{
	if( GetSetting( "BoxLocation" ) == -1 || GetSetting( "BoxLocation" ) == -2 )
		return;

	while( 1 ) 
	{
		while( !GetSetting( "FireSaleActive" ) )
			wait .01;
		level thread SetupFireSaleAudio();
		level thread StartFireSale();
		while( GetSetting( "FireSaleActive" ) )
			wait .01;
		level notify( "FireSaleOver" );
	}
}

SetupFireSaleAudio()
{
	Sounds( "2D", GetSetting( "FireSaleVox" ) );
	Chest = GetChest();
	for( i = 0; i < Chest.size; i++ )
		Chest[i] thread PlayFireSaleAudio();
}

PlayFireSaleAudio()
{
	Org = Spawn( "script_origin", self.origin );
	Sounds( "Loop", GetSetting( "FireSale" ), Org );
	level waittill( "FireSaleOver" );
	Org StopLoopSound();
	Org Delete();
}

StartFireSale()
{
	while( flag( "moving_chest_now" ) )
		wait .01;
	Lights = CreateFireSaleChest();
	level waittill( "FireSaleOver" );
	DestroyFireSaleChest( Lights );
}

DestroyFireSaleChest( Lights )
{
	for( i = 0; i < Lights.size; i++ )
		Lights[i] Delete();
	Chest = GetChest();
	for( i = 0; i < Chest.size; i++ ) 
	{
		// if( !IsTrue( Chest[i].ChestOpen ) )
		//	self SetHintString( GetSetting( "OpenString" ) );
		if( Chest[i] != Chest[GetSetting( "BoxLocation" )] && !IsTrue( Chest[i].ChestOpen ) )
			Chest[i] thread HideChest();
		else if( Chest[i] != Chest[GetSetting( "BoxLocation" )] && IsTrue( Chest[i].ChestOpen ) )
			Chest[i] thread WaitToHide();
	}
}

InitHackableBox()
{
	Trigger = Spawn( "trigger_radius", self.origin, 0, 48, 72 );
	Trigger UseTriggerRequireLookAt();
	Trigger SetCursorHint( "HINT_NOICON" );
	Trigger thread UpdateHintString( self );
	Trigger thread WatchHackedReset( self );

	while( 1 )
	{
		Trigger waittill( "trigger", user );
		if( IsPlayer( user ) && user UseButtonPressed() && user GetCurrentWeapon() == GetSetting( "Hacker" ) && !IsNotEmpty( GetSetting( "Hacker" ) ) )
		{
			if( IsTrue( self.ChestOpen ) )
			{
				if( self.hacking_attempts == 0 )
					self RespinBox( user );
				else if( self.hacking_attempts == 1 )
					self Respinx2Box( user );
			}
			else if( !IsTrue( self.ChestOpen ) && !GetSetting( "FireSaleActive" ) && GetChest()[GetSetting( "BoxLocation" )] != self )
				self SummonChest( user );
		}
		wait .1;
	}
}

Respinx2Box( User )
{
	if( flag( "moving_chest_now" ) ) // Extra check so no flag needed up top
		return;

	self.hacking_attempts++;
	self.is_in_powerup_form = true;
	User maps\_zombiemode_score::minus_to_player_score( GetSetting( "Respinx2HackCost" ) );
	self notify( "box_respin2_hack" );
	self notify( "kill_weapon_movement" );
	self.box_model moveTo( self.origin + vectorScale( ( 0, 0, 1 ), 40 ), 0.5 );
	self thread FakeWeaponPowerupThread();
}

FakeWeaponPowerupThread()
{
	PlayFXOnTag( level._effect[GetSetting( "SoloPowerupFx" )], self.box_model, "tag_origin" );
	Sounds( "Pos", GetSetting( "SpawnPO" ), undefined, self.box_model.origin );
	Sounds( "Loop", GetSetting( "POLoop" ), self.box_model );
	self thread FakeWeaponPowerupTimeout();
	while( IsDefined( self.box_model ) )
	{
		Time = RandomFloatRange( 2.5, 5 );
		Yaw = RandomInt( 360 );
		if( Yaw > 300 )
			Yaw = 300;
		if( Yaw < 60 )
			Yaw = 60;
		Yaw = self.box_model.angles[1] + Yaw;
		self.box_model RotateTo( ( -60 + RandomInt( 120 ), Yaw, -45 + RandomInt( 90 ) ), Time, Time * 0.5, Time * 0.5 );
		wait RandomFloat( Time - 0.1 );
	}
}

FakeWeaponPowerupTimeout()
{
	wait 15;
	for( i = 0; i < 40; i++ )
	{
		if( i % 2 )
			self.box_model Hide();
		else
			self.box_model Show();

		if( i < 15 ) {
			wait .5;
			continue;
		}
		else if( i < 25 ) {
			wait .25;
			continue;
		}
		else
			wait .1;
	}
	self notify( "trigger", level );
	self.box_model delete();
}

RespinBox( User )
{
	if( flag( "moving_chest_now" ) ) // Extra check so no flag needed up top
		return;

	self.hacking_attempts++;
	User maps\_zombiemode_score::minus_to_player_score( GetSetting( "RespinHackCost" ) );
	self notify( "box_respin_hack" );
	self.no_fly_away = true;
	self ChestWeaponSpawn( self, User );

	self waittill( "RandomizationDone" );

	self thread TreasureChestTimeout();
	self.no_fly_away = undefined;
}

WatchHackedReset( Chest )
{
	Item = GetCloseChest( Chest );
	while( 1 )
	{
		Item waittill_any( "ChestMoved", "WeaponGrabbed" );
		self.hacking_attempts = 0;
	}
}

UpdateHintString( Chest )
{
	while( 1 )
	{
		while( distance( self.origin, get_closest_player( self.origin ) ) <= 64 && self AnyPlayerWithWeapon( GetSetting( "Hacker" ) ) )
		{
			if( IsTrue( Chest.ChestOpen ) )
			{
				if( self.hacking_attempts == 0 && self GetStringStatus() != "RespinHack" ) {
					self UpdateStringStatus( "RespinHack" );
					self SetHintString( GetSetting( "RespinString" ) );
					if( IsTrue( self.trigger_off ) )	
						self trigger_on();
				}
				else if( self.hacking_attempts == 1 && self GetStringStatus() != "Respinx2Hack" ) {
					self UpdateStringStatus( "Respinx2Hack" );
					self SetHintString( GetSetting( "Respinx2String" ) );
					if( IsTrue( self.trigger_off ) )
						self trigger_on();
				}
				else if( self GetStringStatus() != "NotAvailable" ) {
					self UpdateStringStatus( "NotAvailable" );
					self SetHintString( GetSetting( "NotAvailable" ) );
					if( !IsTrue( self.trigger_off ) )
						self trigger_off();
				}
			}
			else if( !IsTrue( Chest.ChestOpen ) && !GetSetting( "FireSaleActive" ) && GetChest()[GetSetting( "BoxLocation" )] != Chest && self GetStringStatus() != "ComeHack" && self IsBoxQualified() ) {
				self UpdateStringStatus( "ComeHack" );
				self SetHintString( GetSetting( "HackString" ) );
				if( IsTrue( self.trigger_off ) )
					self trigger_on();
			}
			else if( self GetStringStatus() != "NotAvailable" ) {
				self UpdateStringStatus( "NotAvailable" );
				self SetHintString( GetSetting( "NotAvailable" ) );
				if( !IsTrue( self.trigger_off ) )
					self trigger_off();
			}
			wait .05;
		}
		wait .05;
	}
}

AnyPlayerWithWeapon( Weapon )
{
	for( i = 0; i < GetPlayers().size; i++ )
	{
		if( GetPlayers()[i] GetCurrentWeapon() == Weapon && !IsNotEmpty( Weapon ) )
			return true;
	}
	return false;
}

SummonChest( User )
{
	if( flag( "moving_chest_now" ) || GetChest()[GetSetting( "BoxLocation" )] == self ) // Extra check so no flag needed up top
		return;

	if( !self IsBoxQualified() )
		return;

	User maps\_zombiemode_score::minus_to_player_score( GetSetting( "SummonHackCost" ) );

	self.last_hacked_round = level.round_number + RandomIntRange( 2, 5 );
	self ShowChest();

	self.forced_user = User;
	self.auto_open = true;
	self.no_fly_away = true;
	self.no_charge = false;
	self notify( "trigger", level );

	self waittill_any( "ChestMoved", "WeaponGrabbed" );

	self.forced_user = undefined;
	self.auto_open = undefined;
	self.no_fly_away = undefined;
	self.no_charge = undefined;

	self HideChest();
}

IsBoxQualified()
{
	if( IsDefined( self.last_hacked_round ) && self.last_hacked_round > level.round_number )
		return false;
	return true;
}

WatchHintStringStatus()
{
	// Not using default box string system due to issues + easier to change if in 1 function
	self SetCursorHint( "HINT_NOICON" );
	self UpdateStringStatus( "Undefined" );
	while( 1 ) 
	{
		if( !IsTrue( self.ChestOpen ) && !GetSetting( "FireSaleActive" ) && self GetStringStatus() != "Open" ) {
			self UpdateStringStatus( "Open" );
			self SetHintString( GetSetting( "OpenString" ) );
		}
		else if( !IsTrue( self.ChestOpen ) && GetSetting( "FireSaleActive" ) && self GetStringStatus() != "OpenF" ) {
			self UpdateStringStatus( "OpenF" );
			self SetHintString( GetSetting( "FireSaleOpenString" ) );
		}
		else if( IsTrue( self.ChestOpen ) && self GetStringStatus() != "Trade" ) {
			self UpdateStringStatus( "Trade" );
			self SetHintString( GetSetting( "TradeString" ) );
		}
		wait .05;
	}
}

WaitToHide()
{
	while( IsTrue( self.ChestOpen ) )
		wait .05;
	self thread HideChest();
}

CreateFireSaleChest()
{
	Chest = GetChest();
	Light = [];
	for( i = 0; i < Chest.size; i++ )
	{
		if( Chest[i] != Chest[GetSetting( "BoxLocation" )] ) {
			Light[Light.size] = PandoraLight( i, true );
			Chest[i] thread ShowChest();
		}
		// if( !IsTrue( Chest[i].ChestOpen ) )
		//	self SetHintString( GetSetting( "FireSaleOpenString" ) );
	}
	return Light;
}

TreasureChestThink()
{
	while( 1 )
	{
		user = undefined;
		while( 1 )
		{
			if( !IsDefined( self.forced_user ) )
			{
				self waittill( "trigger", user );
				if( user == level )
					continue;
				if( user in_revive_trigger() )
				{
					wait .1;
					continue;
				}
			}
			else
				user = self.forced_user;
			if( user maps\_laststand::player_is_in_laststand() || !IsAlive( user ) )
				continue;
			Cost = GetSetting( "BoxCost" );
			if( IsPlayer( user ) && user.score >= Cost || IsTrue( self.auto_open ) ) {
				if( !IsTrue( self.no_charge ) )
					user maps\_zombiemode_score::minus_to_player_score( Cost );
				break;
			}
		}
		self disable_trigger();
		self OpenChest();
		if( !IsDefined( level.chestUsed ) )
			level.chestUsed = 0;
		level.chestUsed++;
		WeapSpawn = GetWeaponSpawn( self );
		WeapSpawn thread ChestWeaponSpawn( self, user );
		WeapSpawn thread ChestGlowFx( "ChestMoved2", "WeaponGrabbed", self );
		WeapSpawn waittill( "RandomizationDone" );
		if( flag( "moving_chest_now" ) )
			self thread ChestMove();
		else
			self thread WeaponGrab( user, WeapSpawn );
		self waittill_any( "ChestMoved", "WeaponGrabbed" );
		self CloseChest();
		wait 1;
		if( self == GetChest()[GetSetting( "BoxLocation" )] || GetSetting( "BoxLocation" ) == -1 || GetSetting( "FireSaleActive" ) )
			self enable_trigger();
		if( IsTrue( self.auto_open ) )
			break;
	}
}

WeaponGrab( user, WeapSpawn )
{
	self thread TreasureChestTimeout();
	self enable_trigger();
	while( 1 )
	{
		self waittill( "trigger", player );
		if( player == level ) break;
		if( player CanBuyWeapon() && player == user )
			player thread UpdatePrimaryWeapons( WeapSpawn.weapon );
		else if( player CanBuyWeapon() && player != user && ( IsValidTime( self.timer, GetSetting( "PlayerTakeTime" ) ) || IsTrue( self.is_in_powerup_form ) ) )
			player thread UpdatePrimaryWeapons( WeapSpawn.weapon );
		else continue;
		break;
	}
	self disable_trigger();
	self notify( "WeaponGrabbed" );
}

ChestGlowFx( Notify1, Notify2, Model )
{
	FX = spawn( "script_model", self.origin + ( 0, 0, 0 ) ); 
	FX setmodel( "tag_origin" ); 
	FX.angles = self.angles +( 90, 0, 0 ); 
	PlayFxOnTag( level._effect[GetSetting( "OpenFx" )], FX, "tag_origin"  ); 
	Model waittill_any( Notify2, Notify1 );
	FX Delete();
}

IsValidTime( Time, Num )
{
	if( Time >= Num ) return true;
	return false;
}

TreasureChestTimeout()
{
	self endon( "WeaponGrabbed" );
	self endon( "box_respin2_hack" );
	self.timer = 0;
	while( 1 )
	{
		wait 1;
		self.timer++;
		if( self.timer >= GetSetting( "BoxOpenTime" ) )
			break;
	}
	self notify( "trigger", level );
}

CanBuyWeapon()
{
	if( IsPlaceableMine( self GetCurrentWeapon() ) ) return false;
	if( IsDefined( self.revivetrigger ) || !IsAlive( self ) ) return false;
	if( IsTrue( self.is_drinking ) ) return false;
	return true;
}

ChestMove()
{
	self notify( "ChestMoved2" );
	level.Vars["ChestMoved"] = true;
	self MoveChestInitial();
	Chest = GetChest();
	FindNextChest();
	wait RandomIntRange( 5, 10 );
	Chest[GetSetting( "BoxLocation" )] MoveChestEnd();
	flag_clear( "moving_chest_now" );
	self notify( "ChestMoved" );
}

FindNextChest()
{
	Chest = GetChest();
	if( !GetSetting( "ChooseNextBoxRandom" ) )
		level.BoxSettings["BoxLocation"]++;
	else
	{
		LastSpot = level.BoxSettings["BoxLocation"];
		level.BoxSettings["BoxLocation"] = RandomInt( Chest.size );
		while( level.BoxSettings["BoxLocation"] == LastSpot )
			level.BoxSettings["BoxLocation"] = RandomInt( Chest.size );
	}
	if( level.BoxSettings["BoxLocation"] >= Chest.size )
		level.BoxSettings["BoxLocation"] = 0;
}

MoveChestInitial()
{
	Model = GetTop( self );
	if( !GetSetting( "IsAnimated" ) )
	{
		self CloseChest();

		Parts = [];
		FakeParts = [];

		xModel = GetBottom( self );
		Parts[Parts.size] = xModel;
		Parts[Parts.size] = Model;

		for( i = 0; i < Parts.size; i++ )
		{
			FakeParts[i] = Spawn( "script_model", Parts[i].origin );
			FakeParts[i].angles = Parts[i].angles;
			FakeParts[i] SetModel( Parts[i].model );
			Parts[i] Hide();
		}
		Anchor = Spawn( "script_model", FakeParts[0].origin );
		Sounds( "Play", GetSetting( "BoxMove" ), Anchor );
		for( i = 0; i < FakeParts.size; i++ )
			FakeParts[i] LinkTo( Anchor );
		Sounds( "Pos", GetSetting( "BoxLeave" ), undefined, Anchor.origin );
		Sounds( "Pos", GetSetting( "BoxVox" ), undefined, Anchor.origin );
		Anchor MoveTo( Anchor.origin + ( 0, 0, 50 ), 5 );
		Anchor Vibrate( ( 0, 50, 0 ), 10, 0.5, 5 );
		Anchor waittill( "movedone" );
		Sounds( "Pos", GetSetting( "BoxPoof" ), undefined, Anchor.origin );
		for( i = 0; i < FakeParts.size; i++ )
			FakeParts[i] Delete();

		Rubble = GetTeddy( self );
		Rubble Show();
		self disable_trigger();
	}
	else {
		Model = GetBottom( self );
		Sounds( "Play", GetSetting( "BoxMove" ), Model );
		Sounds( "Pos", GetSetting( "BoxLeave" ), undefined, Model.origin );
		Sounds( "Pos", GetSetting( "BoxVox" ), undefined, Model.origin );
		Model ForceAnimateBox( GetSetting( "AnimatedLeave" ) );
		Sounds( "Pos", GetSetting( "BoxPoof" ), undefined, Model.origin );
		self HideChest();
	}
}

MoveChestEnd()
{
	level notify( "BoxLocFound" );
	self ShowChest();
	if( GetSetting( "IsAnimated" ) ) {
		Model = GetBottom( self );
		Model ForceAnimateBox( GetSetting( "AnimatedArrive" ) );
	}
}

ChestChooseRandomWeapon( Player, Chest )
{
	Keys = GetArrayKeys( level.zombie_weapons );
	Filter = [];
	for( i = 0; i < Keys.size; i++ )
	{
		if( !IsDefined( Keys[i] ) || IsInBox( Keys[i], Chest ) || IsInPaP( Keys[i] ) || Player maps\_zombiemode_weapons::has_weapon_or_upgrade( Keys[i] ) || !IsTrue( level.zombie_weapons[Keys[i]].is_in_box ) )
			continue;
		Filter[Filter.size] = Keys[i];
	}
	return( Filter[RandomInt( Filter.size )] );
}

ChestChooseWeightedRandomWeapon( Player, Chest )
{
	Keys = GetArrayKeys( level.zombie_weapons );
	Filter = [];
	for( i = 0; i < Keys.size; i++ )
	{
		if( !IsDefined( Keys[i] ) || IsInBox( Keys[i], Chest ) || IsInPaP( Keys[i] ) || Player maps\_zombiemode_weapons::has_weapon_or_upgrade( Keys[i] ) || !IsTrue( level.zombie_weapons[Keys[i]].is_in_box ) || PlayerHasLimited( Keys[i] ) )
			continue;
		Num = [[level.weapon_weighting_funcs[Keys[i]]]]();
		for( a = 0; a < Num; a++ )
			Filter[Filter.size] = Keys[i];
	}
	return( Filter[RandomInt( Filter.size )] );
}

ChestChooseBO2Result( Player, Chest )
{
	Keys = array_randomize( GetArrayKeys( level.zombie_weapons ) );
	for( i = 0; i < Keys.size; i++ )
	{
		if( ChestCanPlayerGetWeapon( Keys[i], Player, Chest ) )
			return Keys[i];
	}
	return Keys[0];
}

ChestCanPlayerGetWeapon( Weap, Player, Chest )
{
	if( !IsDefined( Weap ) )
		return false;
	if( !IsTrue( level.zombie_weapons[Weap].is_in_box ) )
		return false;
	if( IsDefined( Player ) && Player maps\_zombiemode_weapons::has_weapon_or_upgrade( Weap ) )
		return false;
	if( IsInBox( Weap, Chest ) )
		return false;
	if( IsInPaP( Weap ) )
		return false;
	if( PlayerHasLimited( Weap ) )
		return false;
	return true;
}

IsInBox( Weap, Chest )
{
	for( i = 0; i < GetEntArray( "magic_box_weapon_spawn", "targetname" ).size; i++ )
	{
		if( GetWeaponSpawn( Chest ) == GetEntArray( "magic_box_weapon_spawn", "targetname" )[i] )
			continue;
		if( IsDefined( GetEntArray( "magic_box_weapon_spawn", "targetname" )[i].weapon ) && GetEntArray( "magic_box_weapon_spawn", "targetname" )[i].weapon == Weap )
			return true;
	}
	return false;
}

PlayerHasLimited( Weap )
{
	Count = getLimitedCount( Weap );
	Num = 0;

	for( i = 0; i < GetPlayers().size; i++ )
	{
		if( GetPlayers()[i] maps\_zombiemode_weapons::has_weapon_or_upgrade( Weap ) || HasInBox( Weap ) || HasInPaP( Weap ) )
			Num++;
	}
			
	if( Num >= Count )
		return true;
	return false;
}

getLimitedCount( Weap )
{
	if( IsDefined( level.limited_weapons[Weap] ) && level.limited_weapons[Weap] != 0 )
		return level.limited_weapons[Weap];
	return 4;
}

IsInPaP( Weap )
{
	for( i = 0; i < GetEntArray( "zombie_vending_upgrade", "targetname" ).size; i++ )
		if( IsDefined( GetEntArray( "zombie_vending_upgrade", "targetname" )[i].current_weapon ) && GetEntArray( "zombie_vending_upgrade", "targetname" )[i].current_weapon == Weap )
			return true;
	return false;
}

GetWeightResults( Weap )
{
	Num = level.weapon_weighting_funcs[Weap];
	return Num;
}

GetWeaponRarity( Player, Chest )
{
	Weap = undefined;
	for( i = 0; i < 40; i++ )
	{
		if( i < 20 ) 
			wait .05;
		else if( i < 30 ) 
			wait .1;
		else if( i < 35 ) 
			wait .2;
		else if( i < 38 ) 
			wait .3;

		if( !GetSetting( "UseBO2RandSystem" ) )
		{
			if( i + 1 < 40 )
				Weap = ChestChooseRandomWeapon( Player, Chest );
			else
				Weap = ChestChooseWeightedRandomWeapon( Player, Chest );
		}
		else
			Weap = ChestChooseBO2Result( Player, Chest );
		if( IsDefined( Weap ) )
			self SetModel( GetWeaponModel( Weap ) );
	}
	return Weap;
}

ChestWeaponSpawn( xModel, user )
{
	self endon( "box_respin2_hack" );

	Model = Spawn( "script_model", self.origin );
	self.box_model = Model;
	self thread CleanHackedBox( Model );

	Model.angles = self.angles + ( 0, 90, 0 );
	Model MoveTo( Model.origin + ( 0, 0, 30 ), 3, 2, 0.9 );
	self.weapon = Model GetWeaponRarity( user, xModel );
	Num = RandomInt( 100 );
	Teddy = -1;
	if( !SpecialNegativeCase( xModel ) )
	{
		Teddy = level.chestUsed + 20;
		if( !IsDefined( level.ChestMoved ) && level.chestUsed >= 8 )
			Teddy = 100;
		else if( level.chestUsed >= 4 && level.chestUsed < 8 )
		{
			if( Num < 15 ) Teddy = 100;
			else Teddy = -1;
		}
		else if( IsDefined( level.ChestMoved ) && level.chestUsed >= 8 && level.chestUsed < 13 )
		{
			if( Num < 30 ) Teddy = 100;
			else Teddy = -1;
		}
		else if( IsDefined( level.ChestMoved ) && level.chestUsed >= 13 )
		{
			if( Num < 50 ) Teddy = 100;
			else Teddy = -1;
		}
	}
	if( SpecialNegativeCase( xModel ) || GetChest().size <= 1 || AnyChestOpen( xModel ) || GetSetting( "FireSaleActive" ) || IsTrue( self.no_fly_away ) || AnyChestNoFly() ) Teddy = -1;
	if( Num <= Teddy )
	{
		level notify( "MoveChest" );
		Model SetModel( GetSetting( "TeddyModel" ) );
		Model RotateYaw( -90, 0.05 );
		if( GetSetting( "MOTDStyleBox" ) )
			Model thread RotateUp();
		flag_set( "moving_chest_now" );
		level.chestUsed = 0;
		user maps\_zombiemode_score::add_to_player_score( GetSetting( "BoxCost" ) );
		level.ChestMoved = true;
	}
	self notify( "RandomizationDone" );
	if( flag( "moving_chest_now" ) )
	{
		Model MoveZ( 500, 4, 3 );
		Model waittill( "movedone" );
		Model Delete();
	}
	else
	{
		Model thread TimerTilDespawn();
		xModel waittill( "WeaponGrabbed" );
		if( IsDefined( Model ) )
			Model Delete();
	}
}

CleanHackedBox( Model )
{
	self waittill( "box_respin2_hack" );
	Model delete();
}

AnyChestNoFly()
{
	Chest = GetChest();
	Num = 0;
	for( i = 0; i < Chest.size; i++ ) {
		if( IsTrue( Chest[i].no_fly_away ) )
			Num++;
	}
	if( Num >= 1 )
		return true;
	return false;
}

RotateUp()
{
	while( IsDefined( self ) )
	{
		self RotateYaw( 360, 1 );
		wait 1;
	}
}

SpecialNegativeCase( xModel )
{
	if( level.chestUsed < 5 )
		return true;
	return false;
}

TimerTilDespawn()
{
	self endon( "kill_weapon_movement" );
	self MoveTo( self.origin - ( 0, 0, 30 ), 12 );
	wait( GetSetting( "BoxOpenTime" ) );
	if( IsDefined( self ) )
		self delete();
}

OpenChest()
{
	if( !IsTrue( self.ChestOpen ) )
	{
		self.ChestOpen = true;
		if( !GetSetting( "IsAnimated" ) )
		{
			Model = GetTop( self );
			if( IsDefined( Model ) )
				Model RotateRoll( 105, 0.5, 0.5 * 0.5 );
		}
		else
		{
			Model = GetBottom( self );
			Model thread ForceAnimateBox( GetSetting( "AnimatedOpen" ) );
		}
		Sounds( "Pos2", GetSetting( "OpenBox" ), undefined, self.origin );
		Sounds( "Pos2", GetSetting( "BoxMusic" ), undefined, self.origin );
	}
}

CloseChest()
{
	if( IsTrue( self.ChestOpen ) )
	{
		self.ChestOpen = undefined;
		if( !GetSetting( "IsAnimated" ) )
		{
			Model = GetTop( self );
			if( IsDefined( Model ) )
				Model RotateRoll( -105, 0.5, 0.5 * 0.5 );
		}
		else
		{
			Model = GetBottom( self );
			Model thread ForceAnimateBox( GetSetting( "AnimatedClose" ) );
		}
		Sounds( "Pos2", GetSetting( "CloseChest" ), undefined, self.origin );
	}
}

InitStartChest( Chest, Loc )
{
	if( Loc == -1 )
	{
		for( i = 0; i < Chest.size; i++ )
			Chest[i] thread ShowChest();
		return;
	}
	for( i = 0; i < Chest.size; i++ )
	{
		if( i != Loc )
			Chest[i] thread HideChest();
		else
			Chest[i] thread ShowChest();
	}
}

PandoraLight( Val, Mult )
{
	Light = GetBottom( GetChest()[Val] );
	if( IsDefined( Light ) )
	{
		if( IsTrue( Mult ) ) {
			LightModel = spawnSM( Light.origin + ( 0, 0, 0 ), "tag_origin", Light.angles + ( -90, 0, 0 ) );
			PlayFXOnTag( level._effect[GetSetting( "LocationFx" )], LightModel, "tag_origin" );
			return LightModel;
		} 
		else {
			level.LightModel = spawnSM( Light.origin + ( 0, 0, 0 ), "tag_origin", Light.angles + ( -90, 0, 0 ) );
			PlayFXOnTag( level._effect[GetSetting( "LocationFx" )], level.LightModel, "tag_origin" );
			level.LightModel thread WatchMovingBox();
		}
	}
}

WatchMovingBox()
{
	flag_wait( "moving_chest_now" );
	level waittill( "BoxLocFound" );
	Light = GetBottom( GetChest()[GetSetting( "BoxLocation" )] );
	self MoveTo( Light.origin, 0.05 );
	self.angles = Light.angles + ( -90, 0, 0 );
	self thread WatchMovingBox();
}

GetStartLocation( Chest )
{
	if( GetSetting( "BoxLocation" ) == -5 )
	{
		UpdateSetting( "BoxLocation", RandomInt( Chest.size ) );
		while( IsInRemovedZone( GetSetting( Chest[GetSetting( "BoxLocation" )] ) ) )
		{
			UpdateSetting( "BoxLocation", RandomInt( Chest.size ) );
			wait .05;
		}
	}
	else if( GetSetting( "BoxLocation" ) == -4 )
	{
		UpdateSetting( "BoxLocation", RandomInt( Chest.size ) );
		while( IsInZone( GetSetting( Chest[GetSetting( "BoxLocation" )], GetSetting( "StartZone" ) ) ) )
		{
			UpdateSetting( "BoxLocation", RandomInt( Chest.size ) );
			wait .05;
		}
	}
	else if( GetSetting( "BoxLocation" ) == -3 )
		UpdateSetting( "BoxLocation", RandomInt( Chest.size ) );
	else if( GetSetting( "BoxLocation" ) == -2 )
	{
		for( i = 0; i < Chest.size; i++ )
			Chest[i] thread HideChest();

	}
	return GetSetting( "BoxLocation" );
}

UpdatePrimaryWeapons( Weapon )
{
	WeapLimit = self GetWeaponLimit();
	PrimeWeaps = self GetWeaponsListPrimaries();

	if( self HasWeapon( Weapon ) ) 
	{
		self GiveMaxAmmo( Weapon );
		return;
	}

	CurrWeap = undefined;
	if( PrimeWeaps.size >= WeapLimit )
	{
		CurrWeap = self GetCurrentWeapon();
		if( CanUndefineCurrWeap( CurrWeap ) )
			CurrWeap = undefined;
		if( IsDefined( CurrWeap ) && !CanUndefineCurrWeap( Weapon ) ) self TakeWeapon( CurrWeap );
	}
	if( !IsDefined( CurrWeap ) && PrimeWeaps.size >= WeapLimit )
	{
		for( i = 0; i < PrimeWeaps.size; i++ )
		{
			if( PrimeWeaps[i] == GetSetting( "StartPistol" ) )
				continue;
			if( IsEqual( PrimeWeaps[i], GetSetting( "MultPistols" ) ) && GetSetting( "HasMultPistols" ) )
				continue;
			if( !CanUndefineCurrWeap( PrimeWeaps[i] ) )
			{
				self TakeWeapon( PrimeWeaps[i] );
				break;
			}
		}
	}
	if( IsSecondaryGrenade( Weapon ) )
	{
		CertWeaps = GetSpecificItems( "Tactical" );
		for( i = 0; i < CertWeaps.size; i++ )
			if( self HasWeapon( CertWeaps[i] ) )
				self TakeWeapon( CertWeaps[i] );
	}
	if( IsPrimaryGrenade( Weapon ) )
	{
		CertWeaps = GetSpecificItems( "Lethal" );
		for( i = 0; i < CertWeaps.size; i++ )
			if( self HasWeapon( CertWeaps[i] ) )
				self TakeWeapon( CertWeaps[i] );
	}
	if( IsPlaceableMine( Weapon ) )
	{
		CertWeaps = GetSpecificItems( "Equipment" );
		for( i = 0; i < CertWeaps.size; i++ )
			if( self HasWeapon( CertWeaps[i] ) )
				self TakeWeapon( CertWeaps[i] );
	}
	if( Weapon == GetSetting( "Monkey" ) )
		self maps\_zombiemode_cymbal_monkey::player_give_cymbal_monkey();
	else 
	{
		self GiveWeapon( Weapon, 0 );
		self GiveMaxAmmo( Weapon );
	}
	if( !CanUndefineCurrWeap( Weapon ) )
		self SwitchToWeapon( Weapon );
	self maps\_zombiemode_weapons::play_weapon_vo( Weapon );
}

// Box End

// Extra Util Funcs
IsEqual( Item, Array )
{
	for( i = 0; i < Array.size; i++ )
		if( Item == Array[i] )
			return true;
	return false;
}

IsPlaceableMine( Weap )
{
	Mines = GetSpecificItems( "Equipment" );
	for( i = 0; i < Mines.size; i++ )
	{
		if( IsNotEmpty( Mines[i] ) )
			continue;

		if( Mines[i] == Weap )
			return true;
	}
	return false;
}

IsSecondaryGrenade( Weapon )
{
	Weap = GetSpecificItems( "Tactical" );
	for( i = 0; i < Weap.size; i++ )
	{
		if( IsNotEmpty( Weap[i] ) )
			continue;
		
		if( Weapon == Weap[i] )
			return true;
	}
	return false;
}

CanUndefineCurrWeap( Weapon )
{
	if( IsSecondaryGrenade( Weapon ) || IsPrimaryGrenade( Weapon ) || IsPlaceableMine( Weapon ) )
		return true;
	return false;
}

IsPrimaryGrenade( Weapon )
{
	Weap = GetSpecificItems( "Lethal" );
	for( i = 0; i < Weap.size; i++ )
	{
		if( IsNotEmpty( Weap[i] ) )
			continue;
		
		if( Weapon == Weap[i] )
			return true;
	}
	return false;
}

GetSpecificItems( Type )
{
	// Used another system but wont work without modifying _zombiemode_weapons.gsc
	Add = [];
	switch( Type )
	{
		case "Equipment":
			Add[Add.size] = GetSetting( "Betty" );
			Add[Add.size] = GetSetting( "Claymore" );
			Add[Add.size] = GetSetting( "Hacker" );
			for( i = 0; i < level.BoxSettings["Equipment"].size; i++ )
				Add[Add.size] = level.BoxSettings["Equipment"][i];
			break;
		case "Tactical":
			Add[Add.size] = GetSetting( "EMP" );
			Add[Add.size] = GetSetting( "Gersch" );
			Add[Add.size] = GetSetting( "Monkey" );
			Add[Add.size] = GetSetting( "Molotov" );
			Add[Add.size] = GetSetting( "MolotovZomb" );
			Add[Add.size] = GetSetting( "Dolls" );
			Add[Add.size] = GetSetting( "Retriever" );
			Add[Add.size] = GetSetting( "RetrieverUpgraded" );
			for( i = 0; i < level.BoxSettings["TacGrenades"].size; i++ )
				Add[Add.size] = level.BoxSettings["TacGrenades"][i];
			break;
		case "Lethal":
			for( i = 0; i < level.BoxSettings["Grenades"].size; i++ )
				Add[Add.size] = level.BoxSettings["Grenades"][i];
			break;
	}
	return Add;
}

GetStringStatus()
{
	return self.StringStatus;
}

UpdateStringStatus( Status )
{
	self.StringStatus = Status;
}

GetWeaponLimit()
{
	if( IsDefined( self.MuleCount ) )
		return self.MuleCount;
	else if( IsDefined( self.inventorySize ) )
		return self.inventorySize;
	else if( IsDefined( self.inventory ) )
		return self.inventory.size;
	if( self HasPerk( "specialty_extraammo" ) )
		return 3;
	return 2;
}

AnyChestOpen( Model )
{
	Chest = GetChest();
	Num = 0;
	for( i = 0; i < Chest.size; i++ )
		if( Chest[i] != Model && IsTrue( Chest[i].ChestOpen ) )
			Num++;

	if( Model != Chest[GetSetting( "BoxLocation" )] )
		return true;

	if( Num >= 1 )
		return true;
	return false;
}

ForceAnimateBox( Anim )
{
	self UseAnimTree( #animtree );
	self AnimScripted( "Anim Begin", self.origin, self.angles, Anim );
	wait( GetAnimLength( Anim ) );
}

HideChest()
{
	self disable_trigger();
	Items = GetItems( self );
	for( i = 0; i < Items.size; i++ )
	{
		if( IsDefined( Items[i] ) )
			Items[i] Hide();
	}
	if( IsDefined( Items[0] ) )
		Items[0] Show();
}

ShowChest()
{
	self enable_trigger();
	Items = GetItems( self );
	for( i = 0; i < Items.size; i++ )
	{
		if( IsDefined( Items[i] ) )
			Items[i] Show();
	}
	if( IsDefined( Items[0] ) )
		Items[0] Hide();
}

GetItems( Item )
{
	Items = [];
	Items[0] = GetTeddy( Item );
	Items[1] = GetBottom( Item );
	Items[2] = GetTop( Item );
	Items[3] = GetWeaponSpawn( Item );
	return Items;
}

GetChest()
{
	return GetEntArray( "treasure_chest_use", "targetname" );
}

GetCloseChest( Item )
{
	Check = GetEntArray( "treasure_chest_use", "targetname" );
	if( IsDefined( Check ) && Check.size > 1 )
		return( GetClosestModel( Item, Check ) );
	return undefined;
}

GetTeddy( Item )
{
	Check = GetEntArray( "chest_rubble", "targetname" );
	if( IsDefined( Check ) && Check.size > 1 )
		return( GetClosestModel( Item, Check ) );
	return undefined;
}

GetBottom( Item )
{
	Check = GetEntArray( "box_bottom", "targetname" );
	if( IsDefined( Check ) && Check.size > 1 )
		return( GetClosestModel( Item, Check ) );
	return undefined;
}

GetTop( Item )
{
	Check = GetEntArray( "box_lid", "targetname" );
	if( IsDefined( Check ) && Check.size > 1 )
		return( GetClosestModel( Item, Check ) );
	return undefined;
}

GetWeaponSpawn( Item )
{
	Check = GetEntArray( "magic_box_weapon_spawn", "targetname" );
	if( IsDefined( Check ) && Check.size > 1 )
		return( GetClosestModel( Item, Check ) );
	return undefined;
}

GetTeddyBear( Item )
{
	Check = GetEntArray( "permaBear", "targetname" );
	if( IsDefined( Check ) && Check.size > 1 )
		return( GetClosestModel( Item, Check ) );
	return undefined;
}

HasInBox( Weap )
{
	for( i = 0; i < GetEntArray( "magic_box_weapon_spawn", "targetname" ).size; i++ )
	{
		Model = GetEntArray( "magic_box_weapon_spawn", "targetname" )[i];
		if( IsDefined( Model.weapon ) && Model.weapon == Weap )
			return true;
	}
	return false;
}

HasInPaP( Weap )
{
	for( i = 0; i < GetEntArray( "zombie_vending_upgrade", "targetname" ).size; i++ )
	{
		PaP = GetEntArray( "zombie_vending_upgrade", "targetname" )[i];
		if( IsDefined( PaP.current_weapon ) && PaP.current_weapon == Weap )
			return true;
	}
	return false;
}

GetClosestModel( Item, Model )
{
	Num = 2;
	while( Num < 1024 )
	{
		for( i = 0; i < Model.size; i++ )
			if( IsDefined( Model[i] ) )
				if( Distance2d( Item.origin, Model[i].origin ) < Num )
					return Model[i];
		Num *= 2;
	}
	return( maps\_utility::get_closest_point( Item.origin, Model ) );
}

spawnSM( origin, model, angles ) 
{ 
    ent = spawn( "script_model", origin ); 
    ent setModel( model ); 
    if( IsDefined( angles ) ) 
        ent.angles = angles; 
    return ent; 
}

IsInRemovedZone( Item )
{
	for( i = 0; i < GetSetting( "RemoveZones" ).size; i++ )
		if( IsInZone( Item, GetSetting( "RemoveZones" )[i] ) )
			return true;
	return false;
}

IsInZone( Item, Zone )
{
	for( i = 0; i < level.zones[Zone].volumes.size; i++ )
		if( Item IsTouching( level.zones[Zone].volumes[i] ) )
			return true;
	return false;
}

LaunchToArraySound( NumPlay, NumVOXMax )
{
	for( i = 0; i < NumPlay; i++ )
		for( a = 0; a < NumVOXMax; a++ )
			level.ArraySound[i][a] = "plr_" + i + "_vox_box_move_" + a;
}

Sounds( Type, Sound, Ent, Org )
{
	GetPlayers()[0] iPrintLn( Type );
	GetPlayers()[0] iPrintLn( Sound );
	if( !IsNotEmpty( Sound ) )
		return;

	switch( Type )
	{
		case "2D":
			play_sound_2d( Sound );
			break;
		case "Loop":
			Ent PlayLoopSound( Sound );
			break;
		case "Pos":
			PlaySoundAtPosition( Sound, Org );
			break;
		case "Play":
			Ent PlaySound( Sound );
			break;
		case "Pos2":
			play_sound_at_pos( Sound, Org );
			break;
	}
}

IsNotEmpty( Item )
{
	if( IsDefined( Item ) && Item != "" && Item != " " )
		return false;
	return true;
}

AddSetting( Setting, Val )
{
	if( !IsDefined( level.BoxSettings ) )
		level.BoxSettings = [];
	level.BoxSettings[Setting] = Val;
}

UpdateSetting( Setting, Val )
{
	level.BoxSettings[Setting] = Val;
}

GetSetting( Setting )
{
	return level.BoxSettings[Setting];
}

IsTrue( Val )
{
	if( IsDefined( Val ) && Val )
		return true;
	return false;
}

IsFalse( Val )
{
	if( IsDefined( Val ) && !Val )
		return true;
	return false;
}